package com.hzya.frame.voucher.ae.comf.bd.controller;

import cn.hutool.core.lang.Assert;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.mdm.mdmModule.dao.IMdmModuleDao;
import com.hzya.frame.mdm.mdmModule.entity.MdmModuleEntity;
import com.hzya.frame.mdm.mdmModule.service.IMdmModuleService;
import com.hzya.frame.voucher.ae.comf.bd.dao.*;
import com.hzya.frame.voucher.ae.comf.bd.entity.*;
import com.hzya.frame.voucher.ae.comf.bd.entity.vo.*;
import com.hzya.frame.voucher.ae.comf.bd.utils.AccsubjTreeBuilder;
import com.hzya.frame.web.action.DefaultController;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by zydd on 2025-06-04 15:04
 */
@RestController
@RequestMapping("/ae/conf/bd")
public class BdController extends DefaultController {

    @Autowired
    private IAeConfBdOrgBookVODao aeConfBdOrgBookVODao;
    @Autowired
    private IAeConfBdBdinfoDao aeConfBdBdinfoDao;
    @Autowired
    private IAeConfBdAccsubjDao aeConfBdAccsubjDao;
    @Autowired
    private IMdmDBQueryVODAO mdmDBQueryVODAO;

    @Autowired
    private IMdmModuleService mdmModuleService;
    @Autowired
    private IMdmModuleDao mdmModuleDao;

    @Autowired
    private IMdmDbFiledVODAO mdmDbFiledVODAO;

    /**
     * 查询所有公司
     */
    @RequestMapping(value = "/queryOrgVO", method = RequestMethod.POST)
    public JsonResultEntity queryOrgVO(@RequestBody OrgBookVO vo) {
        try {
            List<OrgBookVO> all = aeConfBdOrgBookVODao.queryOrgVO(vo);
            return getSuccessMessageEntity("请求成功", all);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

    /**
     * 查询所有公司账簿信息
     */
    @RequestMapping(value = "/queryOrgBookVO", method = RequestMethod.POST)
    public JsonResultEntity queryOrgBookVO(@RequestBody OrgBookVO vo) {
        try {
            List<OrgBookVO> all = aeConfBdOrgBookVODao.queryOrgBookVO(vo);
            return getSuccessMessageEntity("请求成功", all);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

//    /**
//     * 查询基础数据资源表
//     */
//    @RequestMapping(value = "/queryBdinfoList", method = RequestMethod.POST)
//    public JsonResultEntity queryBdinfoList(@RequestBody AeConfBdBdinfoEntity entity) {
//        try {
//            List<AeConfBdBdinfoEntity> all = aeConfBdBdinfoDao.queryByLike(entity);
//            return getSuccessMessageEntity("请求成功", all);
//        } catch (Exception e) {
//            e.printStackTrace();
//            return getFailureMessageEntity(e.getMessage());
//        }
//    }

    /**
     * 查询基础数据资源表
     */
    @RequestMapping(value = "/queryBdinfoList", method = RequestMethod.POST)
    public JsonResultEntity queryBdinfoList(@RequestBody MdmDbFiledVO entity) {
        try {
            MdmDbFiledVO mdmDbFiledVO = new MdmDbFiledVO();
            mdmDbFiledVO.setMdmType("1");//1、档案 2、单据
            mdmDbFiledVO.setMdmId(entity.getPkBdinfo());
            List<MdmDbFiledVO> all = new ArrayList<>();
            List<MdmDbFiledVO> mdmDbFiledVOList = mdmDbFiledVODAO.queryMdmDbFiledVO(mdmDbFiledVO);

            for (MdmDbFiledVO dbFiledVO : mdmDbFiledVOList) {
                dbFiledVO.setPkBdinfo(dbFiledVO.getMdmId());
                dbFiledVO.setBdcode(dbFiledVO.getMdmCode());
                dbFiledVO.setBdname(dbFiledVO.getMdmName());
                dbFiledVO.setTablepkname("id");
            }

            if (entity.getMdmName() != null) {
                for (MdmDbFiledVO mdmDbFiled : mdmDbFiledVOList) {
                    if (mdmDbFiled.getMdmName().contains(entity.getMdmName())) {
                        all.add(mdmDbFiled);
                    }
                }
            } else {
                all = mdmDbFiledVOList;
            }
            return getSuccessMessageEntity("请求成功", all);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

    /**
     * 查询科目表根据账簿id
     */
    @RequestMapping(value = "/queryAccSubjByOrgBookId", method = RequestMethod.POST)
    public JsonResultEntity queryAccSubjByOrgBookId(@RequestBody AeConfBdAccsubjEntity entity) {
        try {
            Assert.notNull(entity.getPkGlorgbook(), "查询科目表时，账簿id不允许为空");
            List<AeConfBdAccsubjEntity> all = aeConfBdAccsubjDao.query(entity);
            List<AccsubjTreeNode> tree = AccsubjTreeBuilder.buildTree(all);
            return getSuccessMessageEntity("请求成功", tree);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

//    /**
//     * 查询基础数据数据表，直连U8C数据库
//     */
//    @RequestMapping(value = "/queryDataByMap", method = RequestMethod.POST)
//    public JsonResultEntity queryDataByMap(@RequestBody HashMap<String, String> map) {
//        try {
//            if (map.get("tablename") == null || "".equals(map.get("tablename"))) {
//                return getSuccessMessageEntity("请求成功", null);
//            }
//            //查询u8c数据库
//            U8CQueryVO u8CQueryVO = new U8CQueryVO();
//            u8CQueryVO.setDataSourceCode(ProfilesActiveConstant.LETS_PROD_DATE_SOURCE);
//            u8CQueryVO.setTablename(map.get("tablename"));
//            List<Map<String, Object>> objectList = u8CQueryVODAO.queryU8CBD(u8CQueryVO);
//
//            return getSuccessMessageEntity("请求成功", objectList);
//        } catch (Exception e) {
//            e.printStackTrace();
//            return getFailureMessageEntity(e.getMessage());
//        }
//    }

    /**
     * 查询基础数据数据表，查询本地库
     */
    @RequestMapping(value = "/queryDataByMap", method = RequestMethod.POST)
    public JsonResultEntity queryDataByMap(@RequestBody MdmDBQueryVO mdmDBQueryVO) {
        try {
            if (mdmDBQueryVO.getTablename() == null || "".equals(mdmDBQueryVO.getTablename())) {
                return getSuccessMessageEntity("请求成功", null);
            }
            List<Map<String, Object>> objectList = mdmDBQueryVODAO.queryMdmDb(mdmDBQueryVO);

            return getSuccessMessageEntity("请求成功", objectList);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

    /**
     * 查询基础数据数据表
     */
    @RequestMapping(value = "/queryDataPagedByMap", method = RequestMethod.POST)
    public JsonResultEntity queryDataPagedByMap(@RequestBody MdmDBQueryVO mdmDBQueryVO) {
        try {
            if (mdmDBQueryVO.getTablename() == null || "".equals(mdmDBQueryVO.getTablename())) {
                return getSuccessMessageEntity("请求成功", null);
            }
            PageHelper.startPage(mdmDBQueryVO.getPageNum(), mdmDBQueryVO.getPageSize());
            List<Map<String, Object>> objectList = mdmDBQueryVODAO.queryMdmDb(mdmDBQueryVO);
            PageInfo pageInfo = new PageInfo(objectList);

            return getSuccessMessageEntity("请求成功", pageInfo);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

    /**
     * 查询现金流映射表
     */
    @RequestMapping(value = "/queryCashFlowMap", method = RequestMethod.POST)
    public JsonResultEntity queryCashFlowMap(@RequestBody CashFlowVO entity) {
        try {
            List<CashFlowVO> cashFlowVOS = mdmDBQueryVODAO.queryCashflowVO(entity);
            return getSuccessMessageEntity("请求成功", cashFlowVOS);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

    /**
     * 查询科目对应表
     */
    @RequestMapping(value = "/queryGlsubrelation", method = RequestMethod.POST)
    public JsonResultEntity queryGlsubrelation(@RequestBody GlSubrelationVO entity) {
        try {
            List<GlSubrelationVO> glSubrelationVOS = mdmDBQueryVODAO.queryGlsubrelationVO(entity);
            return getSuccessMessageEntity("请求成功", glSubrelationVOS);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

    /**
     * 查询基础档案表bd_bdinfo
     */
    @RequestMapping(value = "/queryBdInfo", method = RequestMethod.POST)
    public JsonResultEntity queryBdInfo(@RequestBody BdBdinfoEntity entity) {
        try {
            List<BdBdinfoEntity> list = mdmDBQueryVODAO.queryBdBdinfoList(entity);
            return getSuccessMessageEntity("请求成功", list);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

    /**
     * 查询辅助核算关联的档案
     */
    @RequestMapping(value = "/queryBdInfoBySubjass", method = RequestMethod.POST)
    public JsonResultEntity queryBdInfoBySubjass(@RequestBody BdAccassitemVO entity) {
        try {
            List<BdAccassitemVO> list = mdmDBQueryVODAO.queryBdInfoBySubjass(entity);

            return getSuccessMessageEntity("请求成功", list);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

    /**
     * 查询辅助核算关联的档案-事项分录可选
     */
    @RequestMapping(value = "/queryBdInfoBySubjassFilter", method = RequestMethod.POST)
    public JsonResultEntity queryBdInfoBySubjassFilter(@RequestBody BdAccassitemVO entity) {
        try {
            List<BdAccassitemVO> all = new ArrayList<>();
            //查询所有关联
            List<BdAccassitemVO> list = mdmDBQueryVODAO.queryBdInfoBySubjass(entity);
            //查询现有的档案
            List<MdmModuleEntity> query = mdmModuleDao.queryMdm(null);
            System.out.println(query);
            for (BdAccassitemVO bdBdinfoEntity : list) {
                for (MdmModuleEntity mdmModuleEntity : query) {
                    if (bdBdinfoEntity.getPkAccassitem().equals(mdmModuleEntity.getU8cDbPk())
                            || bdBdinfoEntity.getPkAccassitem().equals(mdmModuleEntity.getNccDbPk())
                            || bdBdinfoEntity.getPkAccassitem().equals(mdmModuleEntity.getYsDbPk())) {
                        all.add(bdBdinfoEntity);
                        break;
                    }
                }
            }
            return getSuccessMessageEntity("请求成功", all);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }


//    /**
//     *
//     */
//    @RequestMapping(value = "/", method = RequestMethod.POST)
//    public JsonResultEntity (@RequestBody  entity) {
//        try {
//            List<> list = mdmDBQueryVODAO.(entity);
//            return getSuccessMessageEntity("请求成功", list);
//        } catch (Exception e) {
//            e.printStackTrace();
//            return getFailureMessageEntity(e.getMessage());
//        }
//    }
}


