package com.hzya.frame.voucher.ae.comf.module.service.impl;

import cn.hutool.core.lang.Assert;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.mdm.mdmModule.service.IMdmModuleService;
import com.hzya.frame.mdm.mdmModuleDb.dao.IMdmModuleDbDao;
import com.hzya.frame.mdm.mdmModuleDb.entity.MdmModuleDbEntity;
import com.hzya.frame.mdm.mdmModuleDbFileds.dao.IMdmModuleDbFiledsDao;
import com.hzya.frame.mdm.mdmModuleDbFileds.entity.MdmModuleDbFiledsEntity;
import com.hzya.frame.mdm.mdmModuleDbFiledsRule.dao.IMdmModuleDbFiledsRuleDao;
import com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity;
import com.hzya.frame.voucher.ae.comf.module.service.IMdmService;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * Created by zydd on 2025-05-27 15:06
 */
@Service
public class MdmServiceImpl implements IMdmService {

    private int i = 0;

    @Autowired
    private IMdmModuleDbDao mdmModuleDbDao;
    @Autowired
    private IMdmModuleDbFiledsDao mdmModuleDbFiledsDao;
    @Autowired
    private IMdmModuleDbFiledsRuleDao mdmModuleDbFiledsRuleDao;
    @Autowired
    private IMdmModuleService mdmModuleService;


    //根据单据id查询表以及相关字段
    @Override
    public List<MdmModuleDbEntity> queryMdmAndFiledsByMdmId(MdmModuleDbEntity entity) {
        Assert.notNull(entity.getMdmId(), "mdmId不能为空");
        List<MdmModuleDbEntity> res = new ArrayList<>();
        //查询单据
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmModuleDbDao.query(entity);
        //查询字段,1、主表 2、明细 3、操作日志 4、下发日志
        for (MdmModuleDbEntity mdmModuleDbEntity : mdmModuleDbEntityList) {
            if ("3".equals(mdmModuleDbEntity.getDbType()) || "4".equals(mdmModuleDbEntity.getDbType())) {
                continue;
            }
            MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
            mdmModuleDbFiledsEntity.setDbId(mdmModuleDbEntity.getId());
            List<MdmModuleDbFiledsEntity> filedList = mdmModuleDbFiledsDao.query(mdmModuleDbFiledsEntity);
            mdmModuleDbEntity.setSublistMdmModuleDbFileds(filedList);
            res.add(mdmModuleDbEntity);
        }

        return res;
    }

    /**
     * 查询字段rules，查询是否关联别的表
     *
     * @param entity
     * @return
     */
    @Override
    public MdmModuleDbEntity queryMdmAndFiledssByMdmId(MdmModuleDbEntity entity) {
        i = 0;
        List<MdmModuleDbEntity> mdmModuleDbEntityList = queryMdmAndFiledsByMdmId(entity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return null;
        }
        MdmModuleDbEntity mdmModuleDbEntity = mdmModuleDbEntityList.get(0);
        List<MdmModuleDbFiledsEntity> sublistMdmModuleDbFileds = mdmModuleDbEntity.getSublistMdmModuleDbFileds();
        //查询每个字段的rule
        List<MdmModuleDbFiledsEntity> dbEntities = new ArrayList<>();
        if (sublistMdmModuleDbFileds != null && sublistMdmModuleDbFileds.size() > 0) {
            for (int i = 0; i < sublistMdmModuleDbFileds.size(); i++) {
                if ("1".equals(sublistMdmModuleDbFileds.get(i).getViewType())) {
                    dbEntities.add(sublistMdmModuleDbFileds.get(i));
                    MdmModuleDbFiledsRuleEntity ruleEntity = new MdmModuleDbFiledsRuleEntity();
                    ruleEntity.setMdmId(sublistMdmModuleDbFileds.get(i).getMdmId());
                    ruleEntity.setFiledId(sublistMdmModuleDbFileds.get(i).getId());
                    List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntities = mdmModuleDbFiledsRuleDao.queryBase(ruleEntity);
                    sublistMdmModuleDbFileds.get(i).setMdmModuleDbFiledsRules(mdmModuleDbFiledsRuleEntities);
                }
            }
        }
        mdmModuleDbEntity.setSublistMdmModuleDbFileds(dbEntities);

        //根据rule再查询关联的数据
        for (MdmModuleDbFiledsEntity dbEntity : dbEntities) {
            for (MdmModuleDbFiledsRuleEntity filedRule : dbEntity.getMdmModuleDbFiledsRules()) {
                if ("typeOptionRuleForm".equals(filedRule.getFormName()) && "service".equals(filedRule.getRuleCode())) {
                    System.out.println(filedRule.getRuleValue());
                    //根据db_name查询字段
                    queryFiledsByDbname(dbEntity, filedRule);
                }

            }
        }
        return mdmModuleDbEntity;
    }

    /**
     * 根据db_name查询字段，注意循环嵌套
     * 根据rule form_name='typeOptionRuleForm' rule_code='service'
     */
    public void queryFiledsByDbname(MdmModuleDbFiledsEntity dbfiledEntity, MdmModuleDbFiledsRuleEntity filedRule) {
        if (i >= 3) {
            Assert.state(false, "字段：{}，关联层数超过3层，请查询是否存在死循环嵌套", dbfiledEntity.getChName());
        }
        i++;
        //查询表，再查询字段
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setDbName(filedRule.getRuleValue());
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmModuleDbDao.query(mdmModuleDbEntity);
        if (mdmModuleDbEntityList.size() == 0) {
            Assert.state(false, "查询表：{}。失败", filedRule.getRuleValue());
        }
        dbfiledEntity.setMdmModuleDbEntity(mdmModuleDbEntityList.get(0));

        //查询字段
        MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
        mdmModuleDbFiledsEntity.setDbId(mdmModuleDbEntityList.get(0).getId());
        List<MdmModuleDbFiledsEntity> filedList = mdmModuleDbFiledsDao.query(mdmModuleDbFiledsEntity);

        //过滤viewType1
        List<MdmModuleDbFiledsEntity> filedType1 = filedList.stream().filter(dbField -> "1".equals(dbField.getViewType())).collect(Collectors.toList());
        mdmModuleDbEntityList.get(0).setSublistMdmModuleDbFileds(filedType1);

        //查询rule
        for (MdmModuleDbFiledsEntity dbFiledsEntity : filedType1) {
            MdmModuleDbFiledsRuleEntity ruleEntity = new MdmModuleDbFiledsRuleEntity();
            ruleEntity.setMdmId(dbFiledsEntity.getMdmId());
            ruleEntity.setFiledId(dbFiledsEntity.getId());
            List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntities = mdmModuleDbFiledsRuleDao.queryBase(ruleEntity);
            dbFiledsEntity.setMdmModuleDbFiledsRules(mdmModuleDbFiledsRuleEntities);
        }

        //在再判断filedType1中的rule是否有form_name='typeOptionRuleForm' rule_code='service'，有则嵌套，没有则返回
        for (MdmModuleDbFiledsEntity dbFiledEntity : filedType1) {
            for (MdmModuleDbFiledsRuleEntity mdmModuleDbFiledsRule : dbFiledEntity.getMdmModuleDbFiledsRules()) {
                if ("typeOptionRuleForm".equals(mdmModuleDbFiledsRule.getFormName()) && "service".equals(mdmModuleDbFiledsRule.getRuleCode())) {
                    queryFiledsByDbname(dbFiledEntity, mdmModuleDbFiledsRule);
                }
            }
        }
    }
}
