package com.hzya.frame.voucher.ae.comf.subject.controller;

import com.hzya.frame.voucher.ae.comf.subject.entity.AeConfSubjectClassificationEntity;
import com.hzya.frame.voucher.ae.comf.subject.entity.AeConfSubjectContrastEntity;
import com.hzya.frame.voucher.ae.comf.subject.service.IAeConfSubjectClassificationService;
import com.hzya.frame.web.action.DefaultController;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * Created by zydd on 2025-05-30 15:13
 * 分类定义
 */
@RestController
@RequestMapping("/ae/conf/subjectClassification")
public class ClassificationController extends DefaultController {

    @Autowired
    private IAeConfSubjectClassificationService aeConfSubjectClassificationService;

    @RequestMapping(value = "/queryAll", method = RequestMethod.POST)
    public JsonResultEntity queryAll(@RequestBody AeConfSubjectClassificationEntity entity) {
        try {
            List<AeConfSubjectClassificationEntity> all = aeConfSubjectClassificationService.queryAll(entity);
            return getSuccessMessageEntity("请求成功", all);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

    @RequestMapping(value = "/queryById", method = RequestMethod.POST)
    public JsonResultEntity queryById(@RequestBody AeConfSubjectClassificationEntity entity) {
        try {
            AeConfSubjectClassificationEntity aeConfSubjectClassificationEntity = aeConfSubjectClassificationService.queryById(entity);
            return getSuccessMessageEntity("请求成功", aeConfSubjectClassificationEntity);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

    @RequestMapping(value = "/save", method = RequestMethod.POST)
    public JsonResultEntity save(@RequestBody AeConfSubjectClassificationEntity entity) {
        try {
            AeConfSubjectClassificationEntity save = aeConfSubjectClassificationService.saveEntity(entity);
            return getSuccessMessageEntity("请求成功", save);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

    @RequestMapping(value = "/update", method = RequestMethod.POST)
    public JsonResultEntity update(@RequestBody AeConfSubjectClassificationEntity entity) {
        try {
            AeConfSubjectClassificationEntity update = aeConfSubjectClassificationService.updateEntity(entity);
            return getSuccessMessageEntity("请求成功", update);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

    @RequestMapping(value = "/delete", method = RequestMethod.POST)
    public JsonResultEntity delete(@RequestBody AeConfSubjectClassificationEntity entity) {
        try {
            aeConfSubjectClassificationService.deleteEntity(entity);
            return getSuccessMessageEntity("请求成功", null);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity(e.getMessage());
        }
    }

}
